--코드 2-1 사용자 계정 생성 - SYSTEM 계정으로 로그인하여 실행
CREATE USER SQLD IDENTIFIED BY 1234; --사용자 계정 생성
ALTER USER SQLD ACCOUNT UNLOCK; --생성한 사용자 계정의 잠금 해제
GRANT RESOURCE, DBA, CONNECT TO SQLD; --생성한 사용자 계정에게 권한 부여

--코드 2-2 테이블 스페이스 및 임시 테이블 스페이스 생성 - SYSTEM 계정으로 로그인하여 실행
CREATE TABLESPACE SQLD_DATA
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\SQLD_DATA.dbf' SIZE 4G
AUTOEXTEND ON NEXT 512M MAXSIZE UNLIMITED
LOGGING
ONLINE
PERMANENT
EXTENT MANAGEMENT LOCAL AUTOALLOCATE
BLOCKSIZE 8K
SEGMENT SPACE MANAGEMENT AUTO
FLASHBACK ON;
CREATE TEMPORARY TABLESPACE SQLD_TEMP
TEMPFILE 'C:\oraclexe\app\oracle\oradata\XE\SQLD_TEMP.dbf' SIZE 1G
AUTOEXTEND ON NEXT 100M MAXSIZE UNLIMITED;

--코드 2-3 디폴트 및 임시 테이블 스페이스 지정 - SYSTEM 계정으로 로그인하여 실행
ALTER USER SQLD DEFAULT TABLESPACE SQLD_DATA;
ALTER USER SQLD TEMPORARY TABLESPACE SQLD_TEMP;

--상가 데이터
https://www.data.go.kr/tcs/dss/selectFileDataDetailView.do?publicDataPk=15083033

--지하철역승하차 데이터 URL 주소
https://pay.tmoney.co.kr/index.dev

--행정안전부 홈페이지 접속 URL 주소
https://www.mois.go.kr/frt/a01/frtMain.do

--폴더 생성
cd c:\
md SQLD
cd SQLD

--SYSDBA 권한으로 오라클 DBMS 접속
sqlplus "/as SYSDBA"

--코드 2-4 오라클 디렉터리 생성
CREATE OR REPLACE DIRECTORY D_SQLD AS 'C:\SQLD';
GRANT EXECUTE ON DIRECTORY D_SQLD TO SQLD WITH GRANT OPTION;
GRANT WRITE ON DIRECTORY D_SQLD TO SQLD WITH GRANT OPTION;
GRANT READ ON DIRECTORY D_SQLD TO SQLD WITH GRANT OPTION;

--SQL*Plus 접속 해제
quit

--폴더 이동
cd C:\SQLD

--impdp 명령을 이용하여 오라클 덤프 파일을 오라클 DBMS에 적용(임포트)
impdp SQLD/1234 schemas=SQLD directory=D_SQLD dumpfile=EXPORT_SQLD.dmp logfile=EXPORT_SQLD.log

--코드 2-5 실습 데이터 구성 확인
SELECT ROWNUM AS 순번
     , TABLE_NAME AS 테이블명
     , (SELECT L.COMMENTS
          FROM DBA_TAB_COMMENTS L
         WHERE L.OWNER = 'SQLD'
           AND L.TABLE_NAME = A.TABLE_NAME) AS 테이블한글명
     , DATA_CNT AS 테이블행수
     , COUNT(*) OVER() AS 총테이블수
     , SUM(DATA_CNT) OVER() AS 총행수
  FROM
     (
       SELECT TRIM('TB_ADRES_CL') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_ADRES_CL
       UNION ALL
       SELECT TRIM('TB_ADRES_CL_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_ADRES_CL_SE
       UNION ALL
       SELECT TRIM('TB_ADSTRD') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_ADSTRD
       UNION ALL
       SELECT TRIM('TB_AGRDE_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_AGRDE_SE
       UNION ALL
       SELECT TRIM('TB_PLOT_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_PLOT_SE
       UNION ALL
       SELECT TRIM('TB_POPLTN') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_POPLTN
       UNION ALL
       SELECT TRIM('TB_POPLTN_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_POPLTN_SE
       UNION ALL
       SELECT TRIM('TB_RN') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_RN
       UNION ALL
       SELECT TRIM('TB_STDR_INDUST_CL') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_STDR_INDUST_CL
       UNION ALL
       SELECT TRIM('TB_SUBWAY_STATN') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_SUBWAY_STATN
       UNION ALL
       SELECT TRIM('TB_SUBWAY_STATN_TK_GFF') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_SUBWAY_STATN_TK_GFF
       UNION ALL
       SELECT TRIM('TB_TK_GFF_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_TK_GFF_SE
       UNION ALL
       SELECT TRIM('TB_BSSH') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_BSSH
       UNION ALL
       SELECT TRIM('TB_INDUTY_CL') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_INDUTY_CL
       UNION ALL
       SELECT TRIM('TB_INDUTY_CL_SE') AS TABLE_NAME, COUNT(*) DATA_CNT FROM TB_INDUTY_CL_SE
     ) A
;

--SQL 실습환경 구축을 위한 SQL 스크립트 파일 저장 위치
C:\SQLD

--SQL*Plus로 SQLD 계정으로 접속
sqlplus SQLD/1234

--SQL문 실습환경 구축을 위한 SQL 스크립트를 실행
@EXPORT_SQLD_SQL_SCRIPT.sql

--SQL*Plus로 SQLD 계정으로 접속
sqlplus SQLD/1234

--SQL*Plus로 SQLD 계정으로 접속
DROP TABLE TB_BSSH PURGE;
DROP TABLE TB_ADRES_CL PURGE;
DROP TABLE TB_ADRES_CL_SE PURGE;
DROP TABLE TB_RN PURGE;
DROP TABLE TB_STDR_INDUST_CL PURGE;
DROP TABLE TB_INDUTY_CL PURGE;
DROP TABLE TB_INDUTY_CL_SE PURGE;
DROP TABLE TB_PLOT_SE PURGE;
DROP TABLE TB_POPLTN PURGE;
DROP TABLE TB_AGRDE_SE PURGE;
DROP TABLE TB_POPLTN_SE PURGE;
DROP TABLE TB_ADSTRD PURGE;
DROP TABLE TB_SUBWAY_STATN_TK_GFF PURGE;
DROP TABLE TB_SUBWAY_STATN PURGE;
DROP TABLE TB_TK_GFF_SE PURGE;