--코드 8-1 FROM절에서 테이블 앨리어스를 사용한 SQL문
SELECT A.SUBWAY_STATN_NO AS "지하철역번호"
     , A.LN_NM AS "노선명"
     , A.STATN_NM AS "역명"
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '강남'
;

--코드 8-2 FROM절에서 테이블에 앨리어스를 잘못 사용한 SQL문
SELECT A.SUBWAY_STATN_NO AS "지하철역번호"
     , A.LN_NM AS "노선명"
     , A.STATN_NM AS "역명"
  FROM TB_SUBWAY_STATN AS A
 WHERE A.STATN_NM = '강남'
;

--코드 8-3 NULL 허용 칼럼의 출력
SELECT INDUTY_CL_CD
     , INDUTY_CL_NM
     , INDUTY_CL_SE_CD
     , NVL(UPPER_INDUTY_CL_CD, '[NULL]') AS UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL
 WHERE INDUTY_CL_CD LIKE 'O%' --숙박
 ORDER BY INDUTY_CL_SE_CD, INDUTY_CL_CD
;

--코드 8-4 NULL 허용 칼럼은 LIKE 연산에서 비교 불가
SELECT INDUTY_CL_CD
     , INDUTY_CL_NM
     , INDUTY_CL_SE_CD
     , UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL
 WHERE UPPER_INDUTY_CL_CD LIKE 'O%' --숙박
 ORDER BY INDUTY_CL_SE_CD, INDUTY_CL_CD
;

--코드 8-5 업종분류코드(TB_INDUTY_CL)가 'O'인 행까지 출력하는 SQL문
SELECT INDUTY_CL_CD
     , INDUTY_CL_NM
     , INDUTY_CL_SE_CD
     , NVL(UPPER_INDUTY_CL_CD, '[NULL]') AS UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL
 WHERE (    UPPER_INDUTY_CL_CD LIKE 'O%' --숙박
         OR INDUTY_CL_CD = 'O' --숙박
       )
 ORDER BY INDUTY_CL_SE_CD, INDUTY_CL_CD
;

--코드 8-6 주문임시 테이블 생성
CREATE TABLE TB_ORD_8_1_2
(
  ORD_NO CHAR(10)
, ORD_DE CHAR(8) NULL
, PRDT_CD CHAR(6) NOT NULL
, CUST_ID VARCHAR2(20) NOT NULL
, CONSTRAINT PK_TB_ORD_8_1_2 PRIMARY KEY(ORD_NO)
)
;

--코드 8-7 주문임시 테이블에 데이터 입력
INSERT INTO TB_ORD_8_1_2 VALUES ('1000000001', '20210101', 'P00001', 'DBMSEXPERT');
INSERT INTO TB_ORD_8_1_2 VALUES ('1000000002', '20210131', 'P00001', 'DBMSEXPERT');
INSERT INTO TB_ORD_8_1_2 VALUES ('1000000003', NULL      , 'P00001', 'DBMSEXPERT');

COMMIT;


--코드 8-8 주문내역 조회 - BETWEEN A AND B
SELECT ORD_NO, ORD_DE, PRDT_CD, CUST_ID
  FROM TB_ORD_8_1_2
 WHERE ORD_DE BETWEEN '20210101' AND '20210131'
;

--코드 8-9 주문일자(ORD_DE) 칼럼의 값이 NULL인 행까지 출력
SELECT ORD_NO
     , NVL(ORD_DE, '[NULL]') AS ORD_DE
     , PRDT_CD
     , CUST_ID
  FROM TB_ORD_8_1_2
 WHERE (   ORD_DE BETWEEN '20210101' AND '20210131'
        OR ORD_DE IS NULL
       )
;

--코드 8-10 ORDER BY절에 테이블 앨리어스 및 칼럼명 기재
SELECT A.SUBWAY_STATN_NO
     , A.BEGIN_TIME
     , (SELECT L.TK_GFF_SE_NM
          FROM TB_TK_GFF_SE L
         WHERE L.TK_GFF_SE_CD = A.TK_GFF_SE_CD) AS TK_GFF_SE_NM
     , TO_CHAR(A.TK_GFF_CNT) "승하차인원수"
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.STD_YM = '202010'
   AND A.BEGIN_TIME = '0800'
   AND A.END_TIME = '0900'
   AND A.SUBWAY_STATN_NO = '000032' --2호선 강남
 ORDER BY A.TK_GFF_CNT DESC
;

--코드 8-11 ORDER BY절에 SELECT절의 칼럼 앨리어스를 기재
SELECT A.SUBWAY_STATN_NO
     , A.BEGIN_TIME
     , (SELECT L.TK_GFF_SE_NM
          FROM TB_TK_GFF_SE L
         WHERE L.TK_GFF_SE_CD = A.TK_GFF_SE_CD
       ) AS TK_GFF_SE_NM
     , TO_CHAR(A.TK_GFF_CNT) "승하차인원수"
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.STD_YM = '202010'
   AND A.BEGIN_TIME = '0800'
   AND A.END_TIME = '0900'
   AND A.SUBWAY_STATN_NO = '000032' --2호선 강남
 ORDER BY "승하차인원수" DESC
;